Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
24 c3754a5b 2019-05-10 stsp
25 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
26 7b67836a 2019-05-10 stsp
27 f6cae3ed 2020-09-13 naddy git_init()
28 0e673013 2019-01-02 stsp {
29 0b2899f8 2019-08-18 stsp git init -q "$1"
30 0e673013 2019-01-02 stsp }
31 0e673013 2019-01-02 stsp
32 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
33 b32c4525 2020-01-05 stsp {
34 b32c4525 2020-01-05 stsp local repo="$1"
35 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
36 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
37 b32c4525 2020-01-05 stsp fi
38 b32c4525 2020-01-05 stsp }
39 b32c4525 2020-01-05 stsp
40 f6cae3ed 2020-09-13 naddy git_commit()
41 0e673013 2019-01-02 stsp {
42 0e673013 2019-01-02 stsp local repo="$1"
43 0e673013 2019-01-02 stsp shift
44 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
45 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
46 0e673013 2019-01-02 stsp }
47 0e673013 2019-01-02 stsp
48 f6cae3ed 2020-09-13 naddy git_rm()
49 512f0d0e 2019-01-02 stsp {
50 512f0d0e 2019-01-02 stsp local repo="$1"
51 512f0d0e 2019-01-02 stsp shift
52 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
53 512f0d0e 2019-01-02 stsp }
54 512f0d0e 2019-01-02 stsp
55 f6cae3ed 2020-09-13 naddy git_show_head()
56 9c4b8182 2019-01-02 stsp {
57 9c4b8182 2019-01-02 stsp local repo="$1"
58 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
59 9c4b8182 2019-01-02 stsp }
60 9c4b8182 2019-01-02 stsp
61 f6cae3ed 2020-09-13 naddy git_show_branch_head()
62 db32465d 2020-02-07 stsp {
63 db32465d 2020-02-07 stsp local repo="$1"
64 db32465d 2020-02-07 stsp local branch="$2"
65 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
66 db32465d 2020-02-07 stsp }
67 db32465d 2020-02-07 stsp
68 db32465d 2020-02-07 stsp
69 f6cae3ed 2020-09-13 naddy git_show_author_time()
70 bcb49d15 2019-08-14 stsp {
71 bcb49d15 2019-08-14 stsp local repo="$1"
72 01073a5d 2019-08-22 stsp local object="$2"
73 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
74 bcb49d15 2019-08-14 stsp }
75 bcb49d15 2019-08-14 stsp
76 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
77 8e7bd50a 2019-08-22 stsp {
78 8e7bd50a 2019-08-22 stsp local repo="$1"
79 8e7bd50a 2019-08-22 stsp local tag="$2"
80 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
81 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
82 8e7bd50a 2019-08-22 stsp }
83 8e7bd50a 2019-08-22 stsp
84 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
85 818c7501 2019-07-11 stsp {
86 818c7501 2019-07-11 stsp local repo="$1"
87 70551d57 2020-04-24 stsp local commit="$2"
88 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
89 818c7501 2019-07-11 stsp }
90 818c7501 2019-07-11 stsp
91 f6cae3ed 2020-09-13 naddy git_show_tree()
92 03415a1a 2019-06-02 stsp {
93 03415a1a 2019-06-02 stsp local repo="$1"
94 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
95 03415a1a 2019-06-02 stsp }
96 03415a1a 2019-06-02 stsp
97 f6cae3ed 2020-09-13 naddy trim_obj_id()
98 818c7501 2019-07-11 stsp {
99 9439a990 2020-09-16 naddy local trimcount=$1
100 9439a990 2020-09-16 naddy local id=$2
101 818c7501 2019-07-11 stsp
102 9439a990 2020-09-16 naddy local pat=""
103 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
104 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
105 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
106 818c7501 2019-07-11 stsp done
107 818c7501 2019-07-11 stsp
108 818c7501 2019-07-11 stsp echo ${id%$pat}
109 818c7501 2019-07-11 stsp }
110 818c7501 2019-07-11 stsp
111 f6cae3ed 2020-09-13 naddy git_commit_tree()
112 03415a1a 2019-06-02 stsp {
113 03415a1a 2019-06-02 stsp local repo="$1"
114 03415a1a 2019-06-02 stsp local msg="$2"
115 03415a1a 2019-06-02 stsp local tree="$3"
116 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
117 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
118 03415a1a 2019-06-02 stsp }
119 03415a1a 2019-06-02 stsp
120 f6cae3ed 2020-09-13 naddy make_test_tree()
121 0e673013 2019-01-02 stsp {
122 0e673013 2019-01-02 stsp repo="$1"
123 0e673013 2019-01-02 stsp
124 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
125 0e673013 2019-01-02 stsp echo beta > $repo/beta
126 0e673013 2019-01-02 stsp mkdir $repo/gamma
127 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
128 0e673013 2019-01-02 stsp mkdir $repo/epsilon
129 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
130 0e673013 2019-01-02 stsp }
131 0e673013 2019-01-02 stsp
132 f6cae3ed 2020-09-13 naddy make_single_file_repo()
133 e7303626 2020-05-14 stsp {
134 e7303626 2020-05-14 stsp repo="$1"
135 e7303626 2020-05-14 stsp file="$2"
136 e7303626 2020-05-14 stsp
137 e7303626 2020-05-14 stsp mkdir $repo
138 e7303626 2020-05-14 stsp git_init $repo
139 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
140 e7303626 2020-05-14 stsp (cd $repo && git add .)
141 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
142 e7303626 2020-05-14 stsp }
143 e7303626 2020-05-14 stsp
144 f6cae3ed 2020-09-13 naddy get_loose_object_path()
145 e7303626 2020-05-14 stsp {
146 e7303626 2020-05-14 stsp local repo="$1"
147 e7303626 2020-05-14 stsp local id="$2"
148 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
149 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
150 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
151 e7303626 2020-05-14 stsp }
152 e7303626 2020-05-14 stsp
153 f6cae3ed 2020-09-13 naddy get_blob_id()
154 3ce1b845 2019-07-15 stsp {
155 3ce1b845 2019-07-15 stsp repo="$1"
156 3ce1b845 2019-07-15 stsp tree_path="$2"
157 3ce1b845 2019-07-15 stsp filename="$3"
158 3ce1b845 2019-07-15 stsp
159 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
160 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
161 3ce1b845 2019-07-15 stsp }
162 3ce1b845 2019-07-15 stsp
163 f6cae3ed 2020-09-13 naddy test_init()
164 0e673013 2019-01-02 stsp {
165 0e673013 2019-01-02 stsp local testname="$1"
166 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
167 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
168 0e673013 2019-01-02 stsp echo "No test name provided" >&2
169 0e673013 2019-01-02 stsp return 1
170 0e673013 2019-01-02 stsp fi
171 0e673013 2019-01-02 stsp local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
172 0e673013 2019-01-02 stsp mkdir $testroot/repo
173 0e673013 2019-01-02 stsp git_init $testroot/repo
174 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
175 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
176 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
177 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
178 4a1ddfc2 2019-01-12 stsp fi
179 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
180 0e673013 2019-01-02 stsp echo "$testroot"
181 0e673013 2019-01-02 stsp }
182 0e673013 2019-01-02 stsp
183 f6cae3ed 2020-09-13 naddy test_cleanup()
184 0e673013 2019-01-02 stsp {
185 0e673013 2019-01-02 stsp local testroot="$1"
186 fe7842f5 2019-07-14 stsp
187 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
188 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
189 fe7842f5 2019-07-14 stsp ret="$?"
190 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
191 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
192 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
193 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
194 fe7842f5 2019-07-14 stsp return 1
195 fe7842f5 2019-07-14 stsp fi
196 fe7842f5 2019-07-14 stsp
197 0e673013 2019-01-02 stsp rm -rf "$testroot"
198 0e673013 2019-01-02 stsp }
199 0e673013 2019-01-02 stsp
200 f6cae3ed 2020-09-13 naddy test_parseargs()
201 7fb414ae 2020-08-08 stsp {
202 7fb414ae 2020-08-08 stsp args=`getopt q $*`
203 7fb414ae 2020-08-08 stsp if [ $? -ne 0 ]; then
204 7fb414ae 2020-08-08 stsp echo "Supported options:"
205 7fb414ae 2020-08-08 stsp echo " -q: quiet mode"
206 7fb414ae 2020-08-08 stsp exit 2
207 7fb414ae 2020-08-08 stsp fi
208 7fb414ae 2020-08-08 stsp set -- $args
209 7fb414ae 2020-08-08 stsp while [ $# -ne 0 ]; do
210 7fb414ae 2020-08-08 stsp case "$1"
211 7fb414ae 2020-08-08 stsp in
212 7fb414ae 2020-08-08 stsp -q)
213 7fb414ae 2020-08-08 stsp export GOT_TEST_QUIET=1; shift;;
214 7fb414ae 2020-08-08 stsp --)
215 7fb414ae 2020-08-08 stsp shift; break;;
216 7fb414ae 2020-08-08 stsp esac
217 7fb414ae 2020-08-08 stsp done
218 7fb414ae 2020-08-08 stsp }
219 7fb414ae 2020-08-08 stsp
220 f6cae3ed 2020-09-13 naddy run_test()
221 0e673013 2019-01-02 stsp {
222 0e673013 2019-01-02 stsp testfunc="$1"
223 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
224 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
225 7fb414ae 2020-08-08 stsp fi
226 0e673013 2019-01-02 stsp $testfunc
227 0e673013 2019-01-02 stsp }
228 0e673013 2019-01-02 stsp
229 f6cae3ed 2020-09-13 naddy test_done()
230 0e673013 2019-01-02 stsp {
231 0e673013 2019-01-02 stsp local testroot="$1"
232 0e673013 2019-01-02 stsp local result="$2"
233 0e673013 2019-01-02 stsp if [ "$result" == "0" ]; then
234 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
235 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
236 7fb414ae 2020-08-08 stsp echo "ok"
237 7fb414ae 2020-08-08 stsp fi
238 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
239 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
240 3941b73a 2019-05-14 stsp echo "$result"
241 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
242 0e673013 2019-01-02 stsp else
243 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
244 0e673013 2019-01-02 stsp fi
245 0e673013 2019-01-02 stsp }